<?php

namespace Ems\portalGestor\Repository;

use Doctrine\ORM\EntityManager;
use Doctrine\DBAL\Connection;

class VinculoRepository {
    /** @var Connection */
    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }

    public function get(
        int $nrOrg,
        int $nrVinculo
    ) {
        $sql = <<<SQL
            SELECT
                *
            FROM
                GPE_VINCULOM VM
                JOIN GPE_VINCULOH VH ON
                    VH.DTMESCOMPETENC = (
                        SELECT MAX(VH1.DTMESCOMPETENC)
                        FROM GPE_VINCULOH VH1
                        WHERE
                            VH1.NRVINCULOM = VM.NRVINCULOM AND
                            VH1.DTMESCOMPETENC <= SYSDATE AND
                            VH1.NRORG = VM.NRORG
                    ) AND
                    VH.NRVINCULOM = VM.NRVINCULOM AND
                    VH.NRORG = VM.NRORG
                JOIN GPE_PESSOA PE ON
                    PE.NRPESSOA = VM.NRPESSOA AND
                    PE.NRORG = VM.NRORG
            WHERE
                VM.NRORG = :P_NRORG AND
                VM.NRVINCULOM = :P_NRVINCULO
SQL;

        $params = [
            'P_NRORG' => $nrOrg,
            'P_NRVINCULO' => $nrVinculo,
        ];

        $std = $this->connection->prepare($sql);
        $std->execute($params);

        $vinculo = $std->fetch();

        return $vinculo;
    }
}