/* Sistemas Integrados TECNISA

Nome: DTULTATU_CLASSIFICABEM

Descrio:

Atualiza a data de ultima atualizao da tabela CLASSIFICABEM

Criao:
15/01/2009 Frederico Gonalves Moreira da Costa
*/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_CLASSIFICABEM' and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_CLASSIFICABEM
GO

CREATE TRIGGER DTULTATU_CLASSIFICABEM
ON CLASSIFICABEM
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'CLASSIFICABEM',NULL,'CDEMPRESA='+CDEMPRESA+';'+'CDGRUPOBEM='+CDGRUPOBEM+';'+'CDCLASSIFICABEM='+CDCLASSIFICABEM+';',
                               GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE CLASSIFICABEM
      SET DTULTATUCLASBEM = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(CLASSIFICABEM.CDEMPRESA,0) = ISNULL(INSERTED.CDEMPRESA,0)) AND
            (ISNULL(CLASSIFICABEM.CDGRUPOBEM,0) = ISNULL(INSERTED.CDGRUPOBEM,0)) AND
            (ISNULL(CLASSIFICABEM.CDCLASSIFICABEM,0) = ISNULL(INSERTED.CDCLASSIFICABEM,0)) AND
            (ISNULL(CLASSIFICABEM.NMCLASSIFICABEM,0) = ISNULL(INSERTED.NMCLASSIFICABEM,0)) AND
            (ISNULL(CLASSIFICABEM.NMABREVCLASSBEM,0) = ISNULL(INSERTED.NMABREVCLASSBEM,0)) AND
            (ISNULL(CLASSIFICABEM.CDNVCLASSIFIBEM,0) = ISNULL(INSERTED.CDNVCLASSIFIBEM,0)) AND
            (ISNULL(CLASSIFICABEM.CDARVCLASSIFBEM,0) = ISNULL(INSERTED.CDARVCLASSIFBEM,0)) AND
            (ISNULL(CLASSIFICABEM.DSOBSCLASSIFBEM,0) = ISNULL(INSERTED.DSOBSCLASSIFBEM,0)) AND
            (ISNULL(CLASSIFICABEM.CDOPERATUCLBEM,0) = ISNULL(INSERTED.CDOPERATUCLBEM,0));
   END;
END;
GO